Поднимаем DLNA сервер на ubuntu 10.10 с использованием MiniDLNA.

Имея файловый сервер дома и полезный девайс Sony PS3, возникло законое желание проигрывать фильмы музыку и прочее с медиа-сервера на PS3. Прошерстив интернет, нарыл несколько статей на эту тему. В частности cтатья безусловно полезная, но описано для Fedora/CentOS, соответственно чтобы заработало на Ubuntu пришлось слегка поработать напильником. В статье ниже, описан полный процесс сборки и установки DLNA сервера под Ubuntu Linux 10.10. Полагаю, что для 11.04 кардинальных изменений в установке не будет. В качестве собственно DLNA сервера был выбран MiniDLNA AKA ReadyDLNA project. На момент написания статьи, актуальная версия была 1.0.21, насколько я понял, проект развивается достаточно неплохими темпами. На данный момент, актуальная версия 1.0.24, обновил ссылки. Собирать будем из исходников, поскольку готового пакета свежей версии в репозиториях не нашлось. Не нашлось даже не свежей.
Для тех, кому лень собирать самостоятельно — в конце статьи приведены ссылки на мой PPA репозиторй, где можно взять собранные пакеты под Ubuntu, и поставить их via True Ubuntu Way 🙂

Итак, приступим.


Для начала, качаем собственно MiniDLNA отсюда.
В моем случае:

wget "http://downloads.sourceforge.net/project/minidlna/minidlna/1.0.24/minidlna_1.0.24_src.tar.gz?r=http%3A%2F%2Fsourceforge.net%2Fprojects%2Fminidlna%2F&ts=1332055028&use_mirror=ignum" -O /usr/src/minidlna_1.0.24_src.tar.gz
cd /usr/src
tar -zxvf ./minidlna_1.0.24_src.tar.gz
cd /usr/src/minidlna-1.0.24

Внимательно читаем INSTALL, пролезно в любом случае. Для успешной сборки понадобится установить некоторое количество зависимостей, подразумевается что команда выполняется от root:

aptitude install libavcodec-dev libavformat-dev libflac-dev libvorbis-dev libogg-dev libexif-dev libsqlite3-dev libjpeg-dev libid3tag0-dev

После чего, начинаем собственно сборку:

make

После успешной сборки запускам:

make install

что автоматически раскинет файлы по местам. Дальше редактируем собственно конфиг, который лежит тут /etc/minidlna.conf. В моем случае, его содержание следующее:

port=8200
media_dir=/opt
media_dir=A,/media/media/Музыка
media_dir=V,/media/media/Видео
media_dir=P,/media/media/Фотографии
friendly_name=My DLNA Server
db_dir=/var/cache/minidlna
log_dir=/var/log
album_art_names=Cover.jpg/cover.jpg/AlbumArtSmall.jpg/albumartsmall.jpg/AlbumArt.jpg/albumart.jpg/Album.jpg/album.jpg/Folder.jpg/folder.jpg/Thumb.jpg/thumb.jpg
inotify=yes
enable_tivo=no
strict_dlna=no
notify_interval=60
serial=12345678
model_number=1

Сам конфиг мало того что довольно простой, еще и неплохо прокомментирован. Так что заблудиться там сложно.

Запускаем сервер.

Для запуска сервера достаточно выполнить:

minidlna -d -f /etc/minidlna.conf

Запускаем сервер при старте системы

Для начала, необходимо написать скрипт запуска демона и поместить его в /etc/init.d. Вот сам скрипт:

#! /bin/sh
### BEGIN INIT INFO
# Provides:          minidlna
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: MiniDLNA startup script.
# Description:       This file should be used to start MiniDLNA server
#
### END INIT INFO

# Author: Sergey Morozik
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Description of the service"
NAME=minidlna
DAEMON=/usr/sbin/$NAME
DAEMON_ARGS="-f /etc/minidlna.conf"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
		|| return 1
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
		$DAEMON_ARGS \
		|| return 2
	# Add code here, if necessary, that waits for the process to be ready
	# to handle requests from services started subsequently which depend
	# on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
	#
	# If the daemon can reload its configuration without
	# restarting (for example, when it is sent a SIGHUP),
	# then implement that here.
	#
	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
	return 0
}

case "$1" in
  start)
	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
	do_start
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  status)
       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
       ;;
  #reload|force-reload)
	#
	# If do_reload() is not implemented then leave this commented out
	# and leave 'force-reload' as an alias for 'restart'.
	#
	#log_daemon_msg "Reloading $DESC" "$NAME"
	#do_reload
	#log_end_msg $?
	#;;
  restart|force-reload)
	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  *)
	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
	exit 3
	;;
esac

:

Создаем файл /etc/init.d/minidlna и вставляем туда собственно код скрипта:

vim /etc/init.d/minidlna

Даем права на выполнение:

chmod +x /etc/init.d/minidlna

Добавляем в автозапуск при старте системы:

update-rc.d minidlna defaults
update-rc.d minidlna enable

После этих действий ваш MiniDLNA сервер будет корректно запускаться при старте системы, а так же вы сможете управлять запуском и остановкой демона штатными средствами /etc/init.d/minidlna start/stop.

Для ленивых я собрал Ubuntu пакет, который можно загрузить из моего PPA репозитория на launchpad.net. Для этого необходимо подключить репозиторий:

apt-add-repository ppa:morozsm/ppa

И установить пакет:

apt-get update
apt-get install minidlna

Надеюсь данная статья будет полезна.

11 thoughts to “Поднимаем DLNA сервер на ubuntu 10.10 с использованием MiniDLNA.”

    1. Готовый пакет изрядно несвеж. К сожалению у меня нет возможности поддерживать его в актуальном состоянии. Да и собрать MiniDLNA при некоторой сноровке, используя данный мануал — 10 минут работы…

  1. в /opt создал симлинк на /media/USBHDD/path:
    ln -s /media/USBHDD/path my_slname
    подключаюсь TV LG LM640T к серверу miniDLNA, коннект успешен,
    но при попытке воспроизвести файл в лог пишется:

    upnphttp.c:1816: error: Error opening /opt/

    В чем может быть проблема?
    (конфиг в первозданном варианте. ставил из пакета с вашего репозитория.)

    1. Проблема может быть в том что:
      1. miniDLNA сервер не имеет прав доступа к /opt/path
      2. miniDLNA насколько я помню, некорректно работает с симлинками, хотя я могу путать…
      В любом случае, попробуйте вместо симлинка локально смонтировать каталог, по принципу тут: http://blog.msmsoft.info/archives/47

Добавить комментарий